/* @(#)Message.c	3.5 93/09/15 16:50:30 FUJITSU LIMITED. */
/******************************************************************

              Copyright 1991, 1993, 1994 by FUJITSU LIMITED

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and
that both that copyright notice and this permission notice appear
in supporting documentation, and that the name of FUJITSU LIMITED
not be used in advertising or publicity pertaining to distribution
of the software without specific, written prior permission.
FUJITSU LIMITED makes no representations about the suitability of
this software for any purpose.  It is provided "as is" without
express or implied warranty.

FUJITSU LIMITED DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
IN NO EVENT SHALL FUJITSU LIMITED BE LIABLE FOR ANY SPECIAL, INDIRECT
OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
OR PERFORMANCE OF THIS SOFTWARE.

  Author: Takashi Fujiwara     FUJITSU LIMITED 
                               fujiwara@a80.tech.yk.fujitsu.co.jp
          Kiyoaki oya          FUJITSU LIMITED

******************************************************************/

/*  xfeoak : Input Server (kana-kanji covertion front end)	*/
/*         : Version 3.5 (for X11R6)                            */

#include "Xfeoak.h"

typedef struct _message {
    int		 no;
    char	*data;
} Message;

#include "Message.h"

Static char *
GetMessage(no)
int		 no;
{
    static char	 buff[64];
    register int i;

    for(i = 0; i < max_message_no; i++) {
	if (message[i].no == no)
	    return  message[i].data;
    }
    (void)sprintf(buff, "Invalid message no. (%d)", no);
    return buff;
}

void
ErrorMessage(no, a1, a2, a3, a4, a5)
    int			 no;
    unsigned long	 a1, a2, a3, a4, a5;
{
    char		*form;

    form = GetMessage(no);
    (void)fprintf(stderr,"%s error : ", command_name);
    (void)fprintf(stderr, form, a1, a2, a3, a4, a5);
    (void)fprintf(stderr,"\n");
    (void)fflush(stderr);
    return;
}

void
WarningMessage(no, a1, a2, a3, a4, a5)
    int			 no;
    unsigned long	 a1, a2, a3, a4, a5;
{
    char		*form;

    form = GetMessage(no);
    (void)fprintf(stderr,"%s warning : ", command_name);
    (void)fprintf(stderr, form, a1, a2, a3, a4, a5);
    (void)fprintf(stderr,"\n");
    (void)fflush(stderr);
    return;
}
